#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <dodhooks>

#define PLUGIN_NAME			"Free For All addon"
#define PLUGIN_AUTHOR		"Root"
#define PLUGIN_VERSION		"1.0"
#define PLUGIN_CONTACT		"http://steamcommunity.com/id/zadroot/"

#define ALLIES				2
#define AXIS				3

#define DOD_MAXPLAYERS		33

new Handle:g_SwapTeam = INVALID_HANDLE;
new Handle:g_RandomClass = INVALID_HANDLE;
new Handle:g_BlockDrop = INVALID_HANDLE;

new g_iOffset_Health;

public Plugin:myinfo =
{
	name			= PLUGIN_NAME,
	author			= PLUGIN_AUTHOR,
	description		= "Kill everyone you meet!",
	version			= PLUGIN_VERSION,
	url				= PLUGIN_CONTACT
};

public OnPluginStart()
{
	g_SwapTeam = CreateConVar("sm_swapondeath", "1", "Swap player team on death");
	g_RandomClass = CreateConVar("sm_spawnrandom", "0", "Choose player class on respawn");
	g_BlockDrop = CreateConVar ("sm_blockdrop", "1", "Block weapons & ammo from being dropped");

	//RegConsoleCmd("drop", Command_Drop);
	RegConsoleCmd("dropammo", Command_Drop);

	HookEvent("player_team", Event_silent, EventHookMode_Pre);
	HookEvent("player_spawn", Event_player_spawn);
	HookEvent("player_death", Event_player_death);

	HookUserMessage(GetUserMessageId("TextMsg"), Hook_TextMsg, true);
	HookUserMessage(GetUserMessageId("HintText"), Hook_HintText, true);

	if ((g_iOffset_Health = FindSendPropOffs("CDODPlayerResource", "m_iHealth")) == -1)
	{
		SetFailState("Fatal Error: Unable to find offset: \"m_iHealth\"!");
	}
}

public OnMapStart()
{
	new playerResource = FindEntityByClassname(-1, "dod_player_manager");

	if (playerResource != -1)
	{
		SDKHook(playerResource, SDKHook_ThinkPost, OnPlayerResourceThinkPost);
	}

	else
	{
		SetFailState("Fatal Error: Unable to find entity \"dod_player_manager\"!");
	}
}

public OnConfigsExecuted()
{
	ServerCommand("mp_friendlyfire 1");
	ServerCommand("dod_friendlyfiresafezone 0");
	ServerCommand("mp_limitteams 20");
}

public OnClientPostAdminCheck(client)
{
	if(IsClientInGame(client))
	{
		SDKHook(client, SDKHook_ShouldCollide, OnShouldCollide);
	}
}

public Action:Command_Drop(client, args)
{
	if(GetConVarBool(g_BlockDrop))
	{
		if(IsClientConnected(client) && IsClientInGame(client))
		{
			return Plugin_Handled;
		}
	}
	return Plugin_Continue;
}

public Action:Event_silent(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!dontBroadcast && !GetEventBool(event, "silent"))
	{
		SetEventBroadcast(event, true);
	}
	return Plugin_Continue;
}

public Action:Event_player_spawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new String:classstring[64];
	new class = GetEntProp(client, Prop_Send, "m_iPlayerClass");
	new random = GetRandomInt(0, 2);

	if(GetConVarBool(g_RandomClass))
	{
		if(class == 0)
		{
			SetPlayerClass(client, random);
		}
		else if (class == 1)
		{
			Format(classstring, sizeof(classstring), "joinclass %i", 0);
			FakeClientCommand(client, classstring);
		}
		else if(class == 2)
		{
			SetPlayerClass(client, random);
		}
	}

	SetEntityModel(client, "models/player/german_rifleman.mdl");

	CreateTimer(0.2, RemovePistols, client);
}

public Action:Event_player_death(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));

	new client_team = GetClientTeam(client);
	new attacker_team = GetClientTeam(attacker);

	if (client_team == attacker_team && client != attacker)
	{
		SetEntProp(attacker, Prop_Data, "m_iFrags", GetClientFrags(attacker) + 2);
	}

	//SetEntProp(client, Prop_Data, "m_iDeaths", GetClientDeaths(client) - 1);

	if(GetConVarBool(g_SwapTeam))
	{
		if((GetClientTeam(client) == ALLIES || (GetClientTeam(client) == AXIS)))
			CreateTimer(0.5, Timer_SwitchTeam, client);
	}
}

public Action:Hook_TextMsg(UserMsg:msg_id, Handle:bf, const players[], playersNum, bool:reliable, bool:init)
{
	decl String:message[256];
	BfReadString(bf, message, sizeof(message));

	if (StrContains(message, "game_score_allie_point") != -1)
		return Plugin_Handled;

	if (StrContains(message, "game_score_allie_points") != -1)
		return Plugin_Handled;

	if (StrContains(message, "game_score_axis_point") != -1)
		return Plugin_Handled;

	if (StrContains(message, "game_score_axis_points") != -1)
		return Plugin_Handled;

	if (StrContains(message, "game_respawn_as") != -1)
		return Plugin_Handled;

	return Plugin_Continue;
}

public Action:Hook_HintText(UserMsg:msg_id, Handle:bf, const players[], playersNum, bool:reliable, bool:init)
{
	decl String:message[256];
	BfReadString(bf, message, sizeof(message));

	if (StrContains(message, "spotted_a_friend") != -1)
		return Plugin_Handled;

	if (StrContains(message, "careful_around_teammates") != -1)
		return Plugin_Handled;

	if (StrContains(message, "try_not_to_injure_teammates") != -1)
		return Plugin_Handled;

	return Plugin_Continue;
}

public Action:RemovePistols(Handle:timer, any:client)
{
	new class = GetEntProp(client, Prop_Send, "m_iPlayerClass");
	new pistol = GetPlayerWeaponSlot(client, 1);

	if(class == 2)
	{
		if(pistol != -1)
		{
			RemovePlayerItem(client, pistol);
		}
	}
	return Plugin_Handled;
}

public Action:Timer_SwitchTeam(Handle:timer, any:client)
{
	ChangeClientTeam(client, GetOtherTeam(GetClientTeam(client)));

	ShowVGUIPanel(client, "class_ger", INVALID_HANDLE, false);
	ShowVGUIPanel(client, "class_us", INVALID_HANDLE, false);

	return Plugin_Handled;
}

public GetOtherTeam(team)
{
	if(team == AXIS)
		return ALLIES;
	else
		return AXIS;
}

public bool:OnShouldCollide(client, collisionGroup, contentsMask, bool:originalResult)
{
	return true;
}

public OnPlayerResourceThinkPost(entity)
{
	for (new i = 0; i < DOD_MAXPLAYERS; i++)
	{
		SetEntData(entity, g_iOffset_Health + (i * 4), 0);
	}
}